unit uMetaAPI;

interface

const
  // MetaMod ӿڰ汾
  META_INTERFACE_VERSION = '5:13';

  // Flags for CVAR_REGISTER()
  FCVAR_ARCHIVE		    = 1;    // set to cause it to be saved to vars.rc
  FCVAR_USERINFO		  = 2;    // changes the client's info string
  FCVAR_SERVER		    = 4;    // notifies players when changed
  FCVAR_EXTDLL		    = 8;    // defined by external DLL
  FCVAR_CLIENTDLL		  = 16;   // defined by the client dll
  FCVAR_PROTECTED		  = 32;   // It's a server cvar, but we don't send the data since it's a password, etc.  Sends 1 if it's not bland/zero, 0 otherwise as value
  FCVAR_SPONLY		    = 64;   // This cvar cannot be changed by clients connected to a multiplayer server.
  FCVAR_PRINTABLEONLY	= 128;  // This cvar's string cannot contain unprintable characters ( e.g., used for player name etc ).
  FCVAR_UNLOGGED		  = 256;  // If this is a FCVAR_SERVER, don't log changes to the log file / console if we are creating a log

  //Destination types for MESSAGE_BEGIN()
  MSG_BROADCAST       =  0;   // Unreliable to all
  MSG_ONE             =  1;   // Reliable to one (msg_entity)
  MSG_ALL             =  2;   // Reliable to all
  MSG_INIT            =  3;   // Write to the init string
  MSG_PVS             =  4;   // Ents in PVS of org
  MSG_PAS             =  5;   // Ents in PAS of org
  MSG_PVS_R           =  6;   // Reliable to PVS
  MSG_PAS_R           =  7;   // Reliable to PAS
  MSG_ONE_UNRELIABLE  =  8;   // Send to one client, but don't put in reliable stream, put in unreliable datagram (could be dropped)
  MSG_SPEC            =  9;   // Sends to all spectator proxies

type

  ALERT_TYPE = (
  	at_notice,
	  at_console,		// same as at_notice, but forces a ConPrintf, not a message box
  	at_aiconsole,	// same as at_console, but only shown if developer level is 2!
	  at_warning,
  	at_error,
	  at_logged		// Server print to console ( only in multiplayer games ).
	);

  PRINT_TYPE = (
  	print_console,
	  print_center,
  	print_chat
	);

  pcvar_s = ^ cvar_s;
  cvar_s = record
	  name: PChar;
	  _string: PChar;
    flags: Integer;
    value: Single;
    next: pcvar_s;
  end;
  pcvar_t = ^cvar_t;
  cvar_t = cvar_s;

  PEngineFuncs = ^TEngineFuncs;
  TEngineFuncs = record
    pfnPrecacheModel: Pointer;                      // int			(*pfnPrecacheModel)			(char* s);
    pfnPrecacheSound: Pointer;                      // int			(*pfnPrecacheSound)			(char* s);
    pfnSetModel: Pointer;                           // void		(*pfnSetModel)				(edict_t *e, const char *m);
    pfnModelIndex: Pointer;                         // int			(*pfnModelIndex)			(const char *m);
    pfnModelFrames: Pointer;                        // int			(*pfnModelFrames)			(int modelIndex);
    pfnSetSize: Pointer;                            // void		(*pfnSetSize)				(edict_t *e, const float *rgflMin, const float *rgflMax);
    pfnChangeLevel: Pointer;                        // void		(*pfnChangeLevel)			(char* s1, char* s2);
    pfnGetSpawnParms: Pointer;                      // void		(*pfnGetSpawnParms)			(edict_t *ent);
    pfnSaveSpawnParms: Pointer;                     // void		(*pfnSaveSpawnParms)		(edict_t *ent);
    pfnVecToYaw: Pointer;                           // float		(*pfnVecToYaw)				(const float *rgflVector);
    pfnVecToAngles: Pointer;                        // void		(*pfnVecToAngles)			(const float *rgflVectorIn, float *rgflVectorOut);
    pfnMoveToOrigin: Pointer;                       // void		(*pfnMoveToOrigin)			(edict_t *ent, const float *pflGoal, float dist, int iMoveType);
    pfnChangeYaw: Pointer;                          // void		(*pfnChangeYaw)				(edict_t* ent);
    pfnChangePitch: Pointer;                        // void		(*pfnChangePitch)			(edict_t* ent);
    pfnFindEntityByString: Pointer;                 // edict_t*	(*pfnFindEntityByString)	(edict_t *pEdictStartSearchAfter, const char *pszField, const char *pszValue);
    pfnGetEntityIllum: Pointer;                     // int			(*pfnGetEntityIllum)		(edict_t* pEnt);
    pfnFindEntityInSphere: Pointer;                 // edict_t*	(*pfnFindEntityInSphere)	(edict_t *pEdictStartSearchAfter, const float *org, float rad);
    pfnFindClientInPVS: Pointer;                    // edict_t*	(*pfnFindClientInPVS)		(edict_t *pEdict);
    pfnEntitiesInPVS: Pointer;                      // edict_t* (*pfnEntitiesInPVS)			(edict_t *pplayer);
    pfnMakeVectors: Pointer;                        // void		(*pfnMakeVectors)			(const float *rgflVector);
    pfnAngleVectors: Pointer;                       // void		(*pfnAngleVectors)			(const float *rgflVector, float *forward, float *right, float *up);
    pfnCreateEntity: Pointer;                       // edict_t*	(*pfnCreateEntity)			(void);
    pfnRemoveEntity: Pointer;                       // void		(*pfnRemoveEntity)			(edict_t* e);
    pfnCreateNamedEntity: Pointer;                  // edict_t*	(*pfnCreateNamedEntity)		(int className);
    pfnMakeStatic: Pointer;                         // void		(*pfnMakeStatic)			(edict_t *ent);
    pfnEntIsOnFloor: Pointer;                       // int			(*pfnEntIsOnFloor)			(edict_t *e);
    pfnDropToFloor: Pointer;                        // int			(*pfnDropToFloor)			(edict_t* e);
    pfnWalkMove: Pointer;                           // int			(*pfnWalkMove)				(edict_t *ent, float yaw, float dist, int iMode);
    pfnSetOrigin: Pointer;                          // void		(*pfnSetOrigin)				(edict_t *e, const float *rgflOrigin);
    pfnEmitSound: Pointer;                          // void		(*pfnEmitSound)				(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch);
    pfnEmitAmbientSound: Pointer;                   // void		(*pfnEmitAmbientSound)		(edict_t *entity, float *pos, const char *samp, float vol, float attenuation, int fFlags, int pitch);
    pfnTraceLine: Pointer;                          // void		(*pfnTraceLine)				(const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr);
    pfnTraceToss: Pointer;                          // void		(*pfnTraceToss)				(edict_t* pent, edict_t* pentToIgnore, TraceResult *ptr);
    pfnTraceMonsterHull: Pointer;                   // int			(*pfnTraceMonsterHull)		(edict_t *pEdict, const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr);
    pfnTraceHull: Pointer;                          // void		(*pfnTraceHull)				(const float *v1, const float *v2, int fNoMonsters, int hullNumber, edict_t *pentToSkip, TraceResult *ptr);
    pfnTraceModel: Pointer;                         // void		(*pfnTraceModel)			(const float *v1, const float *v2, int hullNumber, edict_t *pent, TraceResult *ptr);
    pfnTraceTexture: Pointer;                       // const char *(*pfnTraceTexture)			(edict_t *pTextureEntity, const float *v1, const float *v2 );
    pfnTraceSphere: Pointer;                        // void		(*pfnTraceSphere)			(const float *v1, const float *v2, int fNoMonsters, float radius, edict_t *pentToSkip, TraceResult *ptr);
    pfnGetAimVector: Pointer;                       // void		(*pfnGetAimVector)			(edict_t* ent, float speed, float *rgflReturn);
    pfnServerCommand: procedure(str: PChar); cdecl;                      // void		(*pfnServerCommand)			(char* str);
    pfnServerExecute: procedure(); cdecl;                      // void		(*pfnServerExecute)			(void);
    pfnClientCommand: procedure(pEdict: Pointer; szFmt: PChar); cdecl varargs;                     // void		(*pfnClientCommand)			(edict_t* pEdict, char* szFmt, ...);
    pfnParticleEffect: Pointer;                     // void		(*pfnParticleEffect)		(const float *org, const float *dir, float color, float count);
    pfnLightStyle: Pointer;                         // void		(*pfnLightStyle)			(int style, char* val);
    pfnDecalIndex: Pointer;                         // int			(*pfnDecalIndex)			(const char *name);
    pfnPointContents: Pointer;                      // int			(*pfnPointContents)			(const float *rgflVector);
    pfnMessageBegin: procedure(msg_dest, msg_type: Integer; pOrigin: PSingle=nil; ed: Pointer=nil); cdecl;                      // void		(*pfnMessageBegin)			(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed);
    pfnMessageEnd: procedure(); cdecl;                         // void		(*pfnMessageEnd)			(void);
    pfnWriteByte: procedure(iValue: Integer); cdecl;                         // void		(*pfnWriteByte)				(int iValue);
    pfnWriteChar: procedure(iValue: Integer); cdecl;                          // void		(*pfnWriteChar)				(int iValue);
    pfnWriteShort: procedure(iValue: Integer); cdecl;                         // void		(*pfnWriteShort)			(int iValue);
    pfnWriteLong: procedure(iValue: Integer); cdecl;                          // void		(*pfnWriteLong)				(int iValue);
    pfnWriteAngle: procedure(flValue: Single); cdecl;                         // void		(*pfnWriteAngle)			(float flValue);
    pfnWriteCoord: procedure(flValue: Single); cdecl;                         // void		(*pfnWriteCoord)			(float flValue);
    pfnWriteString: procedure(sz: PChar); cdecl;                        // void		(*pfnWriteString)			(const char *sz);
    pfnWriteEntity: procedure(iValue: Integer); cdecl;                        // void		(*pfnWriteEntity)			(int iValue);
    pfnCVarRegister: procedure(pCvar: pcvar_t); cdecl;                       // void		(*pfnCVarRegister)			(cvar_t *pCvar);
    pfnCVarGetFloat: function(const szVarName: PChar): Single; cdecl;                       // float		(*pfnCVarGetFloat)			(const char *szVarName);
    pfnCVarGetString: function(const szVarName: PChar): PChar; cdecl;                       // const char*	(*pfnCVarGetString)			(const char *szVarName);
    pfnCVarSetFloat: procedure(const szVarName: PChar; flValue: Single); cdecl;             // void		(*pfnCVarSetFloat)			(const char *szVarName, float flValue);
    pfnCVarSetString: procedure(const szVarName, szValue: PChar); cdecl;                    // void		(*pfnCVarSetString)			(const char *szVarName, const char *szValue);
    pfnAlertMessage: procedure(atype: Integer{ALERT_TYPE}; szFmt: PChar); cdecl varargs;                        // void		(*pfnAlertMessage)			(ALERT_TYPE atype, char *szFmt, ...);
    pfnEngineFprintf: Pointer;                      // void		(*pfnEngineFprintf)			(void *pfile, char *szFmt, ...);
    pfnPvAllocEntPrivateData: Pointer;              // void*		(*pfnPvAllocEntPrivateData)	(edict_t *pEdict, int32 cb);
    pfnPvEntPrivateData: Pointer;                   // void*		(*pfnPvEntPrivateData)		(edict_t *pEdict);
    pfnFreeEntPrivateData: Pointer;                 // void		(*pfnFreeEntPrivateData)	(edict_t *pEdict);
    pfnSzFromIndex: Pointer;                        // const char*	(*pfnSzFromIndex)			(int iString);
    pfnAllocString: Pointer;                        // int			(*pfnAllocString)			(const char *szValue);
    pfnGetVarsOfEnt: Pointer;                       // struct entvars_s*	(*pfnGetVarsOfEnt)			(edict_t *pEdict);
    pfnPEntityOfEntOffset: Pointer;                 // edict_t*	(*pfnPEntityOfEntOffset)	(int iEntOffset);
    pfnEntOffsetOfPEntity: Pointer;                 // int			(*pfnEntOffsetOfPEntity)	(const edict_t *pEdict);
    pfnIndexOfEdict: Pointer;                       // int			(*pfnIndexOfEdict)			(const edict_t *pEdict);
    pfnPEntityOfEntIndex: Pointer;                  // edict_t*	(*pfnPEntityOfEntIndex)		(int iEntIndex);
    pfnFindEntityByVars: Pointer;                   // edict_t*	(*pfnFindEntityByVars)		(struct entvars_s* pvars);
    pfnGetModelPtr: Pointer;                        // void*		(*pfnGetModelPtr)			(edict_t* pEdict);
    pfnRegUserMsg: Pointer;                         // int			(*pfnRegUserMsg)			(const char *pszName, int iSize);
    pfnAnimationAutomove: Pointer;                  // void		(*pfnAnimationAutomove)		(const edict_t* pEdict, float flTime);
    pfnGetBonePosition: Pointer;                    // void		(*pfnGetBonePosition)		(const edict_t* pEdict, int iBone, float *rgflOrigin, float *rgflAngles );
    pfnFunctionFromName: Pointer;                   // uint32 (*pfnFunctionFromName)	( const char *pName );
    pfnNameForFunction: Pointer;                    // const char *(*pfnNameForFunction)		( uint32 function );
    pfnClientPrintf: procedure(pEdict: Pointer; ptype: PRINT_TYPE; szMsg: PChar); cdecl;                       // void		(*pfnClientPrintf)			( edict_t* pEdict, PRINT_TYPE ptype, const char *szMsg ); // JOHN: engine callbacks so game DLL can print messages to individual clients
    pfnServerPrint: procedure(szMsg: PChar); cdecl;                        // void		(*pfnServerPrint)			( const char *szMsg );
    pfnCmd_Args: Pointer;                           // const char *(*pfnCmd_Args)				( void );		// these 3 added
    pfnCmd_Argv: Pointer;                           // const char *(*pfnCmd_Argv)				( int argc );	// so game DLL can easily
    pfnCmd_Argc: Pointer;                           // int			(*pfnCmd_Argc)				( void );		// access client 'cmd' strings
    pfnGetAttachment: Pointer;                      // void		(*pfnGetAttachment)			(const edict_t *pEdict, int iAttachment, float *rgflOrigin, float *rgflAngles );
    pfnCRC32_Init: Pointer;                         // void		(*pfnCRC32_Init)			(CRC32_t *pulCRC);
    pfnCRC32_ProcessBuffer: Pointer;                // void        (*pfnCRC32_ProcessBuffer)   (CRC32_t *pulCRC, void *p, int len);
    pfnCRC32_ProcessByte: Pointer;                  // void		(*pfnCRC32_ProcessByte)     (CRC32_t *pulCRC, unsigned char ch);
    pfnCRC32_Final: Pointer;                        // CRC32_t		(*pfnCRC32_Final)			(CRC32_t pulCRC);
    pfnRandomLong: Pointer;                         // int32		(*pfnRandomLong)			(int32  lLow,  int32  lHigh);
    pfnRandomFloat: Pointer;                        // float		(*pfnRandomFloat)			(float flLow, float flHigh);
    pfnSetView: Pointer;                            // void		(*pfnSetView)				(const edict_t *pClient, const edict_t *pViewent );
    pfnTime: Pointer;                               // float		(*pfnTime)					( void );
    pfnCrosshairAngle: Pointer;                     // void		(*pfnCrosshairAngle)		(const edict_t *pClient, float pitch, float yaw);
    pfnLoadFileForMe: Pointer;                      // byte *      (*pfnLoadFileForMe)         (char *filename, int *pLength);
    pfnFreeFile: Pointer;                           // void        (*pfnFreeFile)              (void *buffer);
    pfnEndSection: Pointer;                         // void        (*pfnEndSection)            (const char *pszSectionName); // trigger_endsection
    pfnCompareFileTime: Pointer;                    // int 		(*pfnCompareFileTime)       (char *filename1, char *filename2, int *iCompare);
    pfnGetGameDir: procedure(szGetGameDir: PChar); cdecl;                         // void        (*pfnGetGameDir)            (char *szGetGameDir);
    pfnCvar_RegisterVariable: Pointer;              // void		(*pfnCvar_RegisterVariable) (cvar_t *variable);
    pfnFadeClientVolume: Pointer;                   // void        (*pfnFadeClientVolume)      (const edict_t *pEdict, int fadePercent, int fadeOutSeconds, int holdTime, int fadeInSeconds);
    pfnSetClientMaxspeed: Pointer;                  // void        (*pfnSetClientMaxspeed)     (const edict_t *pEdict, float fNewMaxspeed);
    pfnCreateFakeClient: Pointer;                   // edict_t *	(*pfnCreateFakeClient)		(const char *netname);	// returns NULL if fake client can't be created
    pfnRunPlayerMove: Pointer;                      // void		(*pfnRunPlayerMove)			(edict_t *fakeclient, const float *viewangles, float forwardmove, float sidemove, float upmove, unsigned short buttons, byte impulse, byte msec );
    pfnNumberOfEntities: Pointer;                   // int			(*pfnNumberOfEntities)		(void);
    pfnGetInfoKeyBuffer: Pointer;                   // char*		(*pfnGetInfoKeyBuffer)		(edict_t *e);	// passing in NULL gets the serverinfo
    pfnInfoKeyValue: Pointer;                       // char*		(*pfnInfoKeyValue)			(char *infobuffer, char *key);
    pfnSetKeyValue: Pointer;                        // void		(*pfnSetKeyValue)			(char *infobuffer, char *key, char *value);
    pfnSetClientKeyValue: Pointer;                  // void		(*pfnSetClientKeyValue)		(int clientIndex, char *infobuffer, char *key, char *value);
    pfnIsMapValid: function(filename: PChar): Integer; cdecl;                         // int			(*pfnIsMapValid)			(char *filename);
    pfnStaticDecal: Pointer;                        // void		(*pfnStaticDecal)			( const float *origin, int decalIndex, int entityIndex, int modelIndex );
    pfnPrecacheGeneric: Pointer;                    // int			(*pfnPrecacheGeneric)		(char* s);
    pfnGetPlayerUserId: function(e: Pointer): Integer; cdecl;                    // int			(*pfnGetPlayerUserId)		(edict_t *e ); // returns the server assigned userid for this player.  useful for logging frags, etc.  returns -1 if the edict couldn't be found in the list of clients
    pfnBuildSoundMsg: Pointer;                      // void		(*pfnBuildSoundMsg)			(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch, int msg_dest, int msg_type, const float *pOrigin, edict_t *ed);
    pfnIsDedicatedServer: Pointer;                  // int			(*pfnIsDedicatedServer)		(void);// is this a dedicated server?
    pfnCVarGetPointer: Pointer;                     // cvar_t		*(*pfnCVarGetPointer)		(const char *szVarName);
    pfnGetPlayerWONId: function(e: Pointer): Cardinal; cdecl;                     // unsigned int (*pfnGetPlayerWONId)		(edict_t *e); // returns the server assigned WONid for this player.  useful for logging frags, etc.  returns -1 if the edict couldn't be found in the list of clients

    // YWB 8/1/99 TFF Physics additions
    pfnInfo_RemoveKey: Pointer;                     // void		(*pfnInfo_RemoveKey)		( char *s, const char *key );
    pfnGetPhysicsKeyValue: Pointer;                 // const char *(*pfnGetPhysicsKeyValue)	( const edict_t *pClient, const char *key );
    pfnSetPhysicsKeyValue: Pointer;                 // void		(*pfnSetPhysicsKeyValue)	( const edict_t *pClient, const char *key, const char *value );
    pfnGetPhysicsInfoString: Pointer;               // const char *(*pfnGetPhysicsInfoString)	( const edict_t *pClient );
    pfnPrecacheEvent: Pointer;                      // unsigned short (*pfnPrecacheEvent)		( int type, const char*psz );
    pfnPlaybackEvent: Pointer;                      // void		(*pfnPlaybackEvent)			( int flags, const edict_t *pInvoker, unsigned short eventindex, float delay, float *origin, float *angles, float fparam1, float fparam2, int iparam1, int iparam2, int bparam1, int bparam2 );

    pfnSetFatPVS: Pointer;                          // unsigned char *(*pfnSetFatPVS)			( float *org );
    pfnSetFatPAS: Pointer;                          // unsigned char *(*pfnSetFatPAS)			( float *org );

    pfnCheckVisibility : Pointer;                   // int			(*pfnCheckVisibility )		( const edict_t *entity, unsigned char *pset );

    pfnDeltaSetField: Pointer;                      // void		(*pfnDeltaSetField)			( struct delta_s *pFields, const char *fieldname );
    pfnDeltaUnsetField: Pointer;                    // void		(*pfnDeltaUnsetField)		( struct delta_s *pFields, const char *fieldname );
    pfnDeltaAddEncoder: Pointer;                    // void		(*pfnDeltaAddEncoder)		( char *name, void (*conditionalencode)( struct delta_s *pFields, const unsigned char *from, const unsigned char *to ) );
    pfnGetCurrentPlayer: Pointer;                   // int			(*pfnGetCurrentPlayer)		( void );
    pfnCanSkipPlayer: Pointer;                      // int			(*pfnCanSkipPlayer)			( const edict_t *player );
    pfnDeltaFindField: Pointer;                     // int			(*pfnDeltaFindField)		( struct delta_s *pFields, const char *fieldname );
    pfnDeltaSetFieldByIndex: Pointer;               // void		(*pfnDeltaSetFieldByIndex)	( struct delta_s *pFields, int fieldNumber );
    pfnDeltaUnsetFieldByIndex: Pointer;             // void		(*pfnDeltaUnsetFieldByIndex)( struct delta_s *pFields, int fieldNumber );

    pfnSetGroupMask: Pointer;                       // void		(*pfnSetGroupMask)			( int mask, int op );

    pfnCreateInstancedBaseline: Pointer;            // int			(*pfnCreateInstancedBaseline) ( int classname, struct entity_state_s *baseline );
    pfnCvar_DirectSet: Pointer;                     // void		(*pfnCvar_DirectSet)		( struct cvar_s *var, char *value );

    // Forces the client and server to be running with the same version of the specified file
    //  ( e.g., a player model ).
    // Calling this has no effect in single player
    pfnForceUnmodified: Pointer;                    // void		(*pfnForceUnmodified)		( FORCE_TYPE type, float *mins, float *maxs, const char *filename );

    pfnGetPlayerStats: procedure(pClient: Pointer; var ping, packet_loss: Integer); cdecl;                     // void		(*pfnGetPlayerStats)		( const edict_t *pClient, int *ping, int *packet_loss );

    pfnAddServerCommand: Pointer;                   // void		(*pfnAddServerCommand)		( char *cmd_name, void (*function) (void) );

    // For voice communications, set which clients hear eachother.
    // NOTE: these functions take player entity indices (starting at 1).
    pfnVoice_GetClientListening: Pointer;           // qboolean	(*pfnVoice_GetClientListening)(int iReceiver, int iSender);
    pfnVoice_SetClientListening: Pointer;           // qboolean	(*pfnVoice_SetClientListening)(int iReceiver, int iSender, qboolean bListen);

    pfnGetPlayerAuthId: function(e: Pointer): PChar; cdecl;                    // const char *(*pfnGetPlayerAuthId)		( edict_t *e );

    // PSV: Added for CZ training map
    //	const char *(*pfnKeyNameForBinding)					( const char* pBinding );

    pfnSequenceGet: Pointer;                        // sequenceEntry_s*	(*pfnSequenceGet)				( const char* fileName, const char* entryName );
    pfnSequencePickSentence: Pointer;               // sentenceEntry_s*	(*pfnSequencePickSentence)		( const char* groupName, int pickMethod, int *picked );

    // LH: Give access to filesize via filesystem
    pfnGetFileSize: Pointer;                        // int			(*pfnGetFileSize)						( char *filename );

    pfnGetApproxWavePlayLen: Pointer;               // unsigned int (*pfnGetApproxWavePlayLen)				(const char *filepath);
    // MDC: Added for CZ career-mode
    pfnIsCareerMatch: Pointer;                      // int			(*pfnIsCareerMatch)						( void );

    // BGC: return the number of characters of the localized string referenced by using "label"
    pfnGetLocalizedStringLength: Pointer;           // int			(*pfnGetLocalizedStringLength)			(const char *label);

    // BGC: added to facilitate persistent storage of tutor message decay values for
    // different career game profiles.  Also needs to persist regardless of mp.dll being
    // destroyed and recreated.
    pfnRegisterTutorMessageShown: Pointer;          // void		(*pfnRegisterTutorMessageShown)			(int mid);
    pfnGetTimesTutorMessageShown: Pointer;          // int			(*pfnGetTimesTutorMessageShown)			(int mid);
    pfnProcessTutorMessageDecayBuffer: Pointer;     // void		(*pfnProcessTutorMessageDecayBuffer)	(int *buffer, int bufferLength);
    pfnConstructTutorMessageDecayBuffer: Pointer;   // void		(*pfnConstructTutorMessageDecayBuffer)	(int *buffer, int bufferLength);
    pfnResetTutorMessageDecayData: Pointer;         // void		(*pfnResetTutorMessageDecayData)		( void );
    pfnQueryClientCvarValue: Pointer;               // void		(*pfnQueryClientCvarValue)				( const edict_t *player, const char *cvarName );
    pfnQueryClientCvarValue2: Pointer;              // void        (*pfnQueryClientCvarValue2)             ( const edict_t *player, const char *cvarName, int requestID );
  end;

  string_t = Integer;
  //qboolean = LongBool; //Integer;

  vec3_t = record
    x, y, z: Single;
  end;

  PGlobalVars = ^TGlobalVars;
  TGlobalVars = record
    time: Single;
    frametime: Single;
    force_retouch: Single;
    mapname: string_t;
    startspot: string_t;
    deathmatch: Single;
    coop: Single;
    teamplay: Single;
    serverflags: Single;
    found_secrets: Single;
    v_forward: vec3_t;            // vec3_t		v_forward;
    v_up: vec3_t;                 // vec3_t		v_up;
    v_right: vec3_t;              // vec3_t		v_right;
    trace_allsolid: Single;
    trace_startsolid: Single;
    trace_fraction: Single;
    trace_endpos: vec3_t;         // vec3_t		trace_endpos;
    trace_plane_normal: vec3_t;   // vec3_t		trace_plane_normal;
    trace_plane_dist: Single;
    trace_ent: Pointer;           // edict_t		*trace_ent;
    trace_inopen: Single;
    trace_inwater: Single;
    trace_hitgroup: Integer;
    trace_flags: Integer;
    msg_entity: Integer;
    cdAudioTrack: Integer;
    maxClients: Integer;
    maxEntities: Integer;
    pStringBase: PChar;           // char	*pStringBase;

    pSaveData: vec3_t;            // void		*pSaveData;
    vecLandmarkOffset: vec3_t;    // vec3_t		vecLandmarkOffset;
  end;

  TPLUG_LOADTIME = (
    PT_NEVER = 0,
  	PT_STARTUP,			// should only be loaded/unloaded at initial hlds execution
	  PT_CHANGELEVEL,		// can be loaded/unloaded between maps
  	PT_ANYTIME,			// can be loaded/unloaded at any time
	  PT_ANYPAUSE		// can be loaded/unloaded at any time, and can be "paused" during a map
  );

  TPL_UNLOAD_REASON = (
  	PNL_NULL = 0,
  	PNL_INI_DELETED,		// was deleted from plugins.ini
  	PNL_FILE_NEWER,			// file on disk is newer than last load
  	PNL_COMMAND,			// requested by server/console command
  	PNL_CMD_FORCED,			// forced by server/console command
  	PNL_DELAYED,			// delayed from previous request; can't tell origin
    //only used for 'real_reason' on MPlugin::unload()
  	PNL_PLUGIN,				// requested by plugin function call
  	PNL_PLG_FORCED,			// forced by plugin function call
  	PNL_RELOAD				// forced unload by reload()
  );
  
  PPlugin_Info = ^TPlugin_Info;
  TPlugin_Info = record
	  ifvers: PChar;              // char *ifvers;				// meta_interface version
  	name: PChar;                // char *name;					// full name of plugin
	  version: PChar;             // char *version;				// version
  	date: PChar;                // char *date;					// date
	  author: PChar;              // char *author;				// author name/email
    url: PChar;                 // char *url;					// URL
	  logtag: PChar;              // char *logtag;				// log message prefix (unused right now)
    loadable: Integer;          // PLUG_LOADTIME loadable;		// when loadable
    unloadable: Integer;        // PLUG_LOADTIME loadable;		// when loadable
  end;
  plid_t = PPlugin_Info;

  // Meta Utility Function table type.
  pmeta_util_funcs_s = ^meta_util_funcs_s;
  meta_util_funcs_s = record
    pfnLogConsole: procedure(plid: plid_t; fmt: PChar);cdecl varargs;     // void		(*pfnLogConsole)		(plid_t plid, const char *fmt, ...);
	  pfnLogMessage: procedure(plid: plid_t; fmt: PChar);cdecl varargs;     // void		(*pfnLogMessage)		(plid_t plid, const char *fmt, ...);
	  pfnLogError: procedure(plid: plid_t; fmt: PChar);cdecl varargs;       // void		(*pfnLogError)			(plid_t plid, const char *fmt, ...);
	  pfnLogDeveloper: procedure(plid: plid_t; fmt: PChar);cdecl varargs;   // void		(*pfnLogDeveloper)	(plid_t plid, const char *fmt, ...);
	  pfnCenterSay: procedure(plid: plid_t; fmt: PChar);cdecl varargs;      // void		(*pfnCenterSay)			(plid_t plid, const char *fmt, ...);
	  pfnCenterSayParms: Pointer; // void		(*pfnCenterSayParms)	(plid_t plid, hudtextparms_t tparms, const char *fmt, ...);
	  pfnCenterSayVarargs: Pointer; // void		(*pfnCenterSayVarargs)	(plid_t plid, hudtextparms_t tparms, const char *fmt, va_list ap);
	  pfnCallGameEntity: Pointer; // qboolean	(*pfnCallGameEntity)	(plid_t plid, const char *entStr,	entvars_t *pev);
	  pfnGetUserMsgID: function(plid: plid_t; msgname: PChar; size: PInteger): Integer; cdecl;  // int			(*pfnGetUserMsgID)		(plid_t plid, const char *msgname, int *size);
	  pfnGetUserMsgName: Pointer; // const char *(*pfnGetUserMsgName)	(plid_t plid, int msgid, int *size);
	  pfnGetPluginPath: Pointer; // const char *(*pfnGetPluginPath)		(plid_t plid);
	  pfnGetGameInfo: Pointer; // const char *(*pfnGetGameInfo)		(plid_t plid, ginfo_t tag);
	  pfnLoadPlugin: Pointer; // int 		(*pfnLoadPlugin)		(plid_t plid, const char *cmdline, PLUG_LOADTIME now, void **plugin_handle);
	  pfnUnloadPlugin: Pointer; // int			(*pfnUnloadPlugin)		(plid_t plid, const char *cmdline, PLUG_LOADTIME now, PL_UNLOAD_REASON reason);
	  pfnUnloadPluginByHandle: Pointer; // int			(*pfnUnloadPluginByHandle) (plid_t plid, void *plugin_handle, PLUG_LOADTIME now, PL_UNLOAD_REASON reason);
	  pfnIsQueryingClientCvar: Pointer; // const char *(*pfnIsQueryingClientCvar) (plid_t plid, const edict_t *pEdict);
	  pfnMakeRequestId: Pointer; // int			(*pfnMakeRequestId)		(plid_t plid);
	  pfnGetHookTables: Pointer; // void		(*pfnGetHookTables)		(plid_t plid, enginefuncs_t **peng, DLL_FUNCTIONS **pdll, NEW_DLL_FUNCTIONS **pnewdll);
    {$ifdef UNFINISHED}
	  pfnHookGameEvent: Pointer; // int			(*pfnHookGameEvent)		(plid_t plid, game_event_t event, event_func_t pfnHandle);
	  pfnHookLogTrigger: Pointer; // int			(*pfnHookLogTrigger)	(plid_t plid, const char *trigger, logmatch_func_t pfnHandle);
	  pfnHookLogString: Pointer; // int			(*pfnHookLogString)		(plid_t plid, const char *string, logmatch_func_t pfnHandle);
	  pfnHookLogRegex: Pointer; // int			(*pfnHookLogRegex)		(plid_t plid, const char *pattern, logmatch_func_t pfnHandle);
	  pfnRemoveHookID: Pointer; // qboolean	(*pfnRemoveHookID)		(plid_t plid, int hookid);
    {$endif} { UNFINISHED }
  end;
  PMetaUtilFuncs = ^TMetaUtilFuncs;
  TMetaUtilFuncs = meta_util_funcs_s;
  pmutil_funcs_t = ^mutil_funcs_t;
  mutil_funcs_t = meta_util_funcs_s;
  PMutilFuncs = ^TMutilFuncs;
  TMutilFuncs = mutil_funcs_t;


var
  g_EngFuncs: TEngineFuncs;
  gpGlobals: PGlobalVars;
  gpMetaUtilFuncs: PMutilFuncs;

function _STRING(offset: string_t): PChar;
function MAKESTRING(str: PChar): string_t;

implementation

uses uAmxxModule;

function _STRING(offset: string_t): PChar;
begin
  Result := gpGlobals.pStringBase + offset;
end;

function MAKESTRING(str: PChar): string_t;
begin
  Result := Cardinal(str) - Cardinal(_STRING(0));
end;

end.
 