<?php require_once("common.php"); ?>
<?php
if(!$logged)
{
	header("Location: ./", true, 302);
	exit;
}
if(array_key_exists("uploadfile", $_FILES))
{
	$autounzip = intval($_POST["autounzip"]);
	setcookie("autounzip", strval($autounzip), 0, "/");
	$errmsg = "";
	$error = $_FILES["uploadfile"]["error"]; 
	if($error!=UPLOAD_ERR_OK)
	{
		$title = "文件上传失败";
		switch($error)
		{
			case UPLOAD_ERR_INI_SIZE:  		// 1
				$errmsg = "上传的文件超过了 php.ini 中 upload_max_filesize 选项限制的值。";
				break;
			case UPLOAD_ERR_FORM_SIZE:  	// 2
				$errmsg = "上传文件的大小超过了 HTML 表单中 MAX_FILE_SIZE 选项指定的值。";
				break;
			case UPLOAD_ERR_PARTIAL:  		// 3
				$errmsg = "文件只有部分被上传。";
				break;
			case UPLOAD_ERR_NO_FILE:			// 4
				$errmsg = "没有文件被上传。";
				break;
			case 5:												// 5
				$errmsg = "文件大小为零。";
				break;
			case UPLOAD_ERR_NO_TMP_DIR:		// 6
				$errmsg = "缺少临时文件夹。";
				break;
			case UPLOAD_ERR_CANT_WRITE:		// 7
				$errmsg = "不能写文件到磁盘。";
				break;
			case UPLOAD_ERR_EXTENSION:		// 8
				$errmsg = "某 PHP 扩展停止了文件上传。";
				break;
			default:
				$errmsg = "未知文件错误。";
		}
	}else{
		$filename = strval($_FILES["uploadfile"]["name"]);
		$tmp_name = strval($_FILES["uploadfile"]["tmp_name"]);
		$target = trim(strval($_POST["target"]));
		$target = str_replace("\\", "/", $target);
		// 如果 $target 不为空，并且最后一个字符不是 "/"，则后面加 "/"	  
		if($target!="" && $target[strlen($target)-1]!='/')
			$target = $target."/";
		if(intval(@strpos($target, "../", 1)))
		{
			$title = "文件上传失败";
			$errmsg = "目标位置不能包含字符串“../”(最前面除外)。";
		} else {
		  // 去掉前面的 "/"
			while($target!="" && $target[0]=="/")
				$target = substr($target, 1);
			$target = iconv("UTF-8", "", $target);
			$target = webmgr_get_mod_path().$target;
			$ext = get_file_ext($filename);
			if(strtolower($ext)=="zip" && $autounzip)
			{
				require_once("zip.php");
				$zip = new Zip();
				$result = $zip->Extract($tmp_name, $target);
				$title = "文件上传并解压完成";
			}else{
				$basename = get_file_basename($filename);			
				// 转换成系统默认编码
				$basename = iconv("UTF-8", "", $basename);
				if(!is_dir($target))
					@mkdir($target, 0777, true);
			  $target .= $basename;
				if(@move_uploaded_file($tmp_name, $target))
				{
					$title = "文件上传成功"; 
					$redirect_url = $_SERVER['PHP_SELF'];
				} else {
					$title = "文件上传失败";
					$errmsg = "执行 move_uploaded_file 失败，可能是目标文件只读或正在使用中。";
				}
			}
		}
	}
	require_once("head.php"); ?>
<center>
<br />
<table border="0" align="center" cellpadding="0" cellspacing="0" class="player" width="600">
  <tr>
    <td align="center" class="light"><b><?php echo $title; ?></b></td>
  </tr>
  <tr>
    <td class="light2" style="padding: 16px 16px 8px 8px;">
		<?php 
		if($errmsg!="")
		{
			echo "<center><b>原因：</b>".HtmlEncode($errmsg)."<BR><BR>";
			echo "<b><a href=\"".$_SERVER['PHP_SELF']."\">返回上传文件页面</a></b></center>";
		} else if (is_object($zip)) {
			echo "<b>详细信息如下：</b><br />\n";
			echo "<ol style=\"list-style-type: decimal; list-style-position: outside\">\n";
			foreach($result as $filename=>$stats)
			{
				$filename = iconv("", "UTF-8", $filename);
				echo "<li>".HtmlEncode($filename);
				if(strrchr($filename,'/')=='/')
					echo "&nbsp;&nbsp;<font color=#00FFFF>[目录]</font>";
				else if ($stats>0)
					echo "&nbsp;&nbsp;<font color=#00FF00>[成功]</font>";
				else
					echo "&nbsp;&nbsp;<font color=#FF0000>[失败]</font>";
				echo "</li>\n";
			}
			echo "</ol>";
		} else { ?>
		<center><b><a href="<?php echo $_SERVER['PHP_SELF']; ?>">3秒钟后返回上传文件页面</a></b></center>
		<?php }		?>
		</td>
  </tr>
</table>
</center>
<?php
} else {
$title = "上传文件";
?>
<?php require_once("head.php"); ?>
<center>
<br />
<table border="0" align="center" cellpadding="0" cellspacing="0" class="player">
  <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" enctype="multipart/form-data">
  <tr>
    <td align="center" class="light"><b>上传文件</b></td>
    </tr>
  <tr>
    <td nowrap class="light1" style="padding-left: 8px; padding-right: 8px;">请选择您要上传的文件：
      <input type="file" name="uploadfile" class="text" size="61" style="width:440px; height:18px; font-size: 12px; line-height:14px;<?php if(stripos($_SERVER["HTTP_USER_AGENT"], "MSIE")==false) { echo " color:#333333; background-color: #eeeeee"; } ?>" />
    </td>
  </tr>
  <tr>
    <td nowrap class="light1" style="padding-left: 8px; padding-right: 8px;">请输入上传的目标位置：
      <input type="text" name="target" class="text" style="width:220px; height:18px; font-size: 12px; line-height:14px;" />
			<?php
				$autounzip = strval($_COOKIE["autounzip"]);
				if($autounzip=="")
					$autounzip = 1;
				else
					$autounzip = intval($autounzip);
			?>
			<input type="checkbox" name="autounzip"<?php if($autounzip) echo " checked=\"checked\""; ?> id="autounzip" value="1">
			<label for="autounzip">自动解压上传的 ZIP 文件</label>
      <input type="submit" class="button" value="上 传"></td>
  </tr>
  <tr>
    <td class="light1" style="padding-left: 8px; padding-right: 8px; padding-top: 4px; padding-bottom: 4px;"><b>上传说明</b>：<b><font color="#FF0000">已存在的文件将会被自动覆盖，请谨慎操作！</font></b>“上传目标位置”基于游戏服务器 MOD 目录，如果留空，则上传到 MOD 目录；如果要上传到 MOD 目录下的子目录，请直接输入子目录名；如果要上传到游戏根目录及其子目录中，请在“上传目标位置”最前面输入“../”(只能在最前面输入一次)。如果选择“自动解压上传的 ZIP 文件”，则当你所上传的文件的扩展名是 ZIP 时，将会自动进行解压，解压时会保留压缩文件原来的目录结构。如果目标目录不存在，将会自动建立。上传和解压所需时间可能较久，请耐心等待。</td>
  </tr>
  </form>
</table>
</center>
<?php } ?>
<?php require_once("foot.php"); ?>
