<?php require_once("common.php"); ?>
<?php
if(!$logged)
{
	header("Location: ./", true, 302);
	exit;
}
if(array_key_exists("uploadfile", $_FILES))
{
	$autounzip = intval($_POST["autounzip"]);
	setcookie("autounzip", strval($autounzip), 0, "/");
	$errmsg = "";
	$error = $_FILES["uploadfile"]["error"]; 
	if($error!=UPLOAD_ERR_OK)
	{
		$title = "Upload file failed";
		switch($error)
		{
			case UPLOAD_ERR_INI_SIZE:  		// 1
				$errmsg = "The uploaded file exceeds the upload_max_filesize in php.ini.";
				break;
			case UPLOAD_ERR_FORM_SIZE:  	// 2
				$errmsg = "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.";
				break;
			case UPLOAD_ERR_PARTIAL:  		// 3
				$errmsg = "The uploaded file was only partially uploaded.";
				break;
			case UPLOAD_ERR_NO_FILE:			// 4
				$errmsg = "No file was uploaded.";
				break;
			case 5:												// 5
				$errmsg = "File size is zero.";
				break;
			case UPLOAD_ERR_NO_TMP_DIR:		// 6
				$errmsg = "Missing a temporary folder.";
				break;
			case UPLOAD_ERR_CANT_WRITE:		// 7
				$errmsg = "Failed to write file to disk.";
				break;
			case UPLOAD_ERR_EXTENSION:		// 8
				$errmsg = "A PHP extension stopped the file upload.";
				break;
			default:
				$errmsg = "Unknown File Error.";
		}
	}else{
		$filename = strval($_FILES["uploadfile"]["name"]);
		$tmp_name = strval($_FILES["uploadfile"]["tmp_name"]);
		$target = trim(strval($_POST["target"]));
		$target = str_replace("\\", "/", $target);
		// if $target is not empty, and last char isn't "/", then add "/" at the end	  
		if($target!="" && $target[strlen($target)-1]!='/')
			$target = $target."/";
		if(intval(@strpos($target, "../", 1)))
		{
			$title = "Upload file failed";
			$errmsg = "\"Upload target\" can not include \"../\"(except at start)。";
		} else {
			while($target!="" && $target[0]=="/")
				$target = substr($target, 1);
			$target = iconv("UTF-8", "", $target);
			$target = webmgr_get_mod_path().$target;
			$ext = get_file_ext($filename);
			if(strtolower($ext)=="zip" && $autounzip)
			{
				require_once("zip.php");
				$zip = new Zip();
				$result = $zip->Extract($tmp_name, $target);
				$title = "Upload & unzip file finish";
			}else{
				$basename = get_file_basename($filename);			
				// 转换成系统默认编码
				$basename = iconv("UTF-8", "", $basename);
				if(!is_dir($target))
					@mkdir($target, 0777, true);
			  $target .= $basename;
				if(@move_uploaded_file($tmp_name, $target))
				{
					$title = "Upload file OK"; 
					$redirect_url = $_SERVER['PHP_SELF'];
				} else {
					$title = "Upload file failed";
					$errmsg = "Failed on function move_uploaded_file, the target file may be is readonly or inuse.";
				}
			}
		}
	}
	require_once("head.php"); ?>
<center>
<br />
<table border="0" align="center" cellpadding="0" cellspacing="0" class="player" width="600">
  <tr>
    <td align="center" class="light"><b><?php echo $title; ?></b></td>
  </tr>
  <tr>
    <td class="light2" style="padding: 16px 16px 8px 8px;">
		<?php 
		if($errmsg!="")
		{
			echo "<center><b>Resean: </b>".HtmlEncode($errmsg)."<BR><BR>";
			echo "<b><a href=\"".$_SERVER['PHP_SELF']."\">Return to upload page</a></b></center>";
		} else if (is_object($zip)) {
			echo "<b>Unzip information:</b><br />\n";
			echo "<ol style=\"list-style-type: decimal; list-style-position: outside\">\n";
			foreach($result as $filename=>$stats)
			{
				$filename = iconv("", "UTF-8", $filename);
				echo "<li>".HtmlEncode($filename);
				if(strrchr($filename,'/')=='/')
					echo "&nbsp;&nbsp;<font color=#00FFFF>[Folder]</font>";
				else if ($stats>0)
					echo "&nbsp;&nbsp;<font color=#00FF00>[OK]</font>";
				else
					echo "&nbsp;&nbsp;<font color=#FF0000>[Failed]</font>";
				echo "</li>\n";
			}
			echo "</ol>";
		} else { ?>
		<center><b><a href="<?php echo $_SERVER['PHP_SELF']; ?>">After 3 seconds, it will be return to upload page</a></b></center>
		<?php }		?>
		</td>
  </tr>
</table>
</center>
<?php
} else {
$title = "Upload file";
?>
<?php require_once("head.php"); ?>
<center>
<br />
<table border="0" align="center" cellpadding="0" cellspacing="0" class="player">
  <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" enctype="multipart/form-data">
  <tr>
    <td align="center" class="light"><b>Upload file</b></td>
    </tr>
  <tr>
    <td nowrap class="light1" style="padding-left: 8px; padding-right: 8px;">Select file to upload:&nbsp;
      <input type="file" name="uploadfile" class="text" size="64" style="width:450px; height:18px; font-size: 12px; line-height:14px;<?php if(stripos($_SERVER["HTTP_USER_AGENT"], "MSIE")==false) { echo " color:#333333; background-color: #eeeeee"; } ?>" />
    </td>
  </tr>
  <tr>
    <td nowrap class="light1" style="padding-left: 8px; padding-right: 8px;">Input upload target:&nbsp; 
      <input type="text" name="target" class="text" style="width:210px; height:18px; font-size: 12px; line-height:14px;" />
			<?php
				$autounzip = strval($_COOKIE["autounzip"]);
				if($autounzip=="")
					$autounzip = 1;
				else
					$autounzip = intval($autounzip);
			?>
			<input type="checkbox" name="autounzip"<?php if($autounzip) echo " checked=\"checked\""; ?> id="autounzip" value="1">
			<label for="autounzip">Auto unzip uploaded ZIP file</label>&nbsp;
      <input type="submit" class="button" style="width: 55px;" value="Upload"></td>
  </tr>
  <tr>
    <td class="light1" style="padding-left: 8px; padding-right: 8px; padding-top: 4px; padding-bottom: 4px;"><b>UPLOAD NOTICE: </b><b><font color="#FF0000">Existing files will be automatically overwrite, please operate caution!</font></b> "Upload target" is base on the game server MOD folder, if empty, then uploaded to the MOD folder; If you want to upload to the MOD subfolder, please enter the folder name; If you want to upload to the root folder of the game or its folders, type "../" at start of "upload target"(can only enter once). If you select "Auto unzip uploaded ZIP file", then when you upload a ZIP file, it will automatically unzip. Unzip will keep the original folder structure. If the target folder does not exist, it will be automatically created. Upload and extract required time may be longer, please be patient.</td>
  </tr>
  </form>
</table>
</center>
<?php } ?>
<?php require_once("foot.php"); ?>
